.586
.model flat
.data
	PUBLIC _ASM_FUNC
	EXTRN _C_FUNC:PROC
	CPU_VALUE		DB 0
.code
	_ASM_FUNC PROC NEAR C

; save caller's ebp to set up for addressing arguments
	push	 ebp 
	mov	 ebp, esp	
; get CPUID
	mov EAX, 1				; get family information function
	CPUID					; pentium instruction
	shr EAX, 8				; move bits 8 to 11 ID to AL
	and EAX, 0Fh			; only use bits 8 to 11 now 0 to 3
	mov CPU_VALUE, AL			; put number into procedure variable
	mov EDX, 0			
	mov DL, AL				; DL contains CPUID
; add CPUID to input number which is 0
	mov EAX, 0
	mov EAX, [ebp+8]
	add EAX, EDX
; prepare stuff to be returned
	push EAX
	call _C_FUNC
; adjust stack and restore caller's ebp
	add esp, 4
	pop ebp
; return
	ret
	_ASM_FUNC ENDP
END 
